<!-- ======= LISTADO CON: EXPORT Y PAGINADOR ======= -->
{% extends 'core/base-tables.html' %}

{% block content %}

  <main id="main">

    <!-- ======= Breadcrumbs ======= -->
    <section id="breadcrumbs" class="breadcrumbs">
      <div class="container-fluid">
        <div class="row justify-content-center">
          <div class="col-xl-10 d-flex align-items-center">
            <div class="col-md-12 text-left" data-aos="fade-up">
              <h2>{{ titulo }}</h2>
              <a href="{{ url_for('Home.index') }}">Inicio</a>
              <i class="icofont-curved-right"></i>Administración
              <i class="icofont-curved-right"></i>Documentos
            </div>
          </div>
        </div>
      </div>
    </section><!-- End Breadcrumbs -->

    <!-- ======= Table-List Section ======= -->
    <section id="list" class="list section-bg">
      <div class="container-fluid">
        <div class="row justify-content-center">
          <div class="col-xl-10 d-flex entries">
            <div class="col-md-12 text-left" data-aos="fade-up">

              <div id="toolbar">
                <span>
                  <a id="new" class="new btn-primary animate__animated animate__fadeInUp" 
                      href="#modalEdit" title="Nuevo" data-toggle="modal">
                    <span><i class="icofont-plus"></i> Documento</span>
                  </a>
                </span>
              </div>

              {% if (datos|count > 0) %}
              <table id="table" class="table table-striped"
                data-toggle="table"
                data-search="true"
                data-search-highlight="true"
                data-show-refresh="true"
                data-show-columns="true"
                data-show-export="true"
                data-pagination="true"
                data-click-to-select="true"
                data-toolbar="#toolbar"
                data-page-list="[25, 50, 100, all]">
                <thead>
                  <tr>
                    <th data-field="codigo" data-align="center" data-sortable="true" data-visible="false">Código</th>
                    <th data-field="titulo" data-align="left" data-sortable="true">Título</th>
                    <th data-field="entidad_autor" data-align="left">Entidad/Autor</th>
                    <th data-field="categoria" data-align="left">Categoría</th>
                    <th data-field="ambito" data-align="left">Ámbito</th>
                    <th data-field="operate" data-align="center" data-formatter="actionsFormatter" data-events="window.actionsEvents">Acciones</th>
                  </tr>
                </thead>          
              </table>
              {% else %}
              <p><br>No se encontraron Documentos.</p>
              {% endif %}
              
            </div>
          </div>
        </div>
      </div>
    </section><!-- End Table-List Section -->

  </main><!-- End #main -->

  <!-- Modal New/Edit HTML -->
  {% include 'admin/documentos/editar.html' %}

{% endblock %}


{% block scripts %}
  <script>
    var $table = $('#table')
    var $new = $('#new')
    
    $('#Etiquetas').on('itemAdded', function(event) {
      // event.item: contains the item added
    });    
    
  
    function actionsFormatter(value, row, index) {
      return [
        '<a class="edit" href="#modalEdit" title="Editar" data-toggle="modal">',
        '<i class="bx bxs-pencil"></i>',
        '</a>',
        '<a class="delete" href="#modalDelete" title="Borrar" data-toggle="modal">',
        '<i class="bx bxs-trash-alt"></i>',
        '</a>'
      ].join('')
    }

    window.actionsEvents = {
      'click .edit': function (e, value, row, index) {
        document.getElementById('formEdit').action="{{url_for('Documentos.action_documento')}}" + '?dbAction=update';
        document.getElementById('titleEdit').innerHTML = 'Editar Documento';
        document.getElementById('Codigo').value = JSON.stringify(row.codigo).replaceAll('"','');
        document.getElementById('Codigo').readOnly = true;
        document.getElementById('CodigoField').hidden = true;
        document.getElementById('Titulo').value = JSON.stringify(row.titulo).replaceAll('"','');
        document.getElementById('Descripcion').value = JSON.stringify(row.descripcion).replaceAll('"','');
        document.getElementById('EntidadAutor').value = JSON.stringify(row.entidad_autor).replaceAll('"','');
        document.getElementById('PaisRegion').value = JSON.stringify(row.pais_region).replaceAll('"','');
        document.getElementById('Referencia').value = JSON.stringify(row.referencia).replaceAll('"','');
        document.getElementById('Tipo').value = JSON.stringify(row.tipo).replaceAll('"','');
        document.getElementById('Eje').value = JSON.stringify(row.eje).replaceAll('"','');
        document.getElementById('Ambito').value = JSON.stringify(row.ambito).replaceAll('"','');
        document.getElementById('Categoria').value = JSON.stringify(row.categoria).replaceAll('"','');
        document.getElementById('Usuario').value = JSON.stringify(row.usuario).replaceAll('"','');
        document.getElementById('Fecha').value = JSON.stringify(row.fecha).replaceAll('"','');
        let et = JSON.stringify(row.etiquetas).replaceAll('"','');
        $('#Etiquetas').tagsinput('removeAll');
        $('#Etiquetas').tagsinput('add', et.substr(1, et.length - 2));
        $('#Etiquetas').tagsinput('refresh');
      },
      'click .delete': function (e, value, row, index) {
        const msg = 'Se eliminará el documento:<br><i>' + JSON.stringify(row.titulo).replaceAll('"','') + '</i>';
        const url = "{{url_for('Documentos.delete_documento')}}" + '?codigo=' + JSON.parse(row.codigo);
        document.getElementById('titleDelete').innerHTML = 'Borrar Documento';
        document.getElementById('msgDelete').innerHTML = msg;
        document.getElementById('formDelete').action = url;
      }
    }

    $.extend($.fn.bootstrapTable.defaults.icons, {
      refresh: 'icofont-refresh',
      columns: 'icofont-navigation-menu',
      export: 'icofont-download'
    });

    $(function() {
      $table.bootstrapTable('destroy').bootstrapTable({
        exportDataType: 'all',
        exportTypes: ['json', 'xml', 'csv', 'txt', 'sql', 'excel', 'pdf'],
        locale: 'es-ES',
        data: {{datos|tojson}}
      });

      // New record
      $new.click(function () {
        document.getElementById('formEdit').action="{{url_for('Documentos.action_documento')}}" + '?dbAction=create';
        document.getElementById('titleEdit').innerHTML = 'Crear Documento';
        document.getElementById('Codigo').value = '';
        document.getElementById('CodigoField').hidden = true;
        document.getElementById('Titulo').value = '';
        document.getElementById('Descripcion').value = '';
        document.getElementById('EntidadAutor').value = '';
        document.getElementById('PaisRegion').value = '';
        document.getElementById('Tipo').value = '';
        document.getElementById('Eje').value = '';
        document.getElementById('Ambito').value = '';
        document.getElementById('Categoria').value = '';
        document.getElementById('Referencia').value = '';
        document.getElementById('Usuario').value = '';
        document.getElementById('Fecha').value = '';
        $('#Etiquetas').tagsinput('removeAll');
      })
    })

  </script>
  
{% endblock %}
